2 # kbuild: Generic definitions
9 space := $(empty) $(empty)
10 space_escape := _-_SPACE_-_
14 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
15 dot-target = $(dir $@).$(notdir $@)
18 # The temporary file to save gcc -MD generated dependencies must not
20 depfile = $(subst $(comma),_,$(dot-target).d)
23 # filename of target with directory and extension stripped
24 basetarget = $(basename $(notdir $@))
27 # filename of first prerequisite with directory and extension stripped
28 baseprereq = $(basename $(notdir $<))
31 # Escape single quote for use in echo statements
32 escsq = $(subst $(squote),'\$(squote)',$1)
35 # real prerequisites without phony targets
36 real-prereqs = $(filter-out $(PHONY), $^)
39 # Easy method for doing a status message
43 kecho := $($(quiet)kecho)
46 # filechk is used to check if the content of a generated file is updated.
48 # define filechk_sample
51 # version.h : Makefile
52 # $(call filechk,sample)
53 # The rule defined shall write to stdout the content of the new file.
54 # The existing file will be compared with the new one.
55 # - If no file exist it is created
56 # - If the content differ the new file is used
57 # - If they are equal no change, and no timestamp update
58 # - stdin is piped in from the first prerequisite ($<) so one has
59 # to specify a valid file as first prerequisite (often the kbuild file)
73 # gcc support functions
74 # See documentation in Documentation/kbuild/makefiles.txt
77 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
78 # Return first prefix where a prefix$(CC) is found in PATH.
79 # If no $(CC) found in PATH with listed prefixes return nothing
81 $(word 1, $(foreach c,$(1), \
83 if (which $(strip $(c))$(CC)) > /dev/null 2>&1 ; then \
87 # output directory for tests below
88 TMPOUT := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/)
91 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
92 # Exit code chooses option. "$$TMP" is can be used as temporary file and
93 # is automatically cleaned up.
94 # modifed for U-Boot: prevent cc-option from leaving .*.su files
95 try-run = $(shell set -e; \
96 TMP="$(TMPOUT).$$$$.tmp"; \
97 TMPO="$(TMPOUT).$$$$.o"; \
98 TMPSU="$(TMPOUT).$$$$.su"; \
99 if ($(1)) >/dev/null 2>&1; \
103 rm -f "$$TMP" "$$TMPO" "$$TMPSU")
106 # Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
108 as-option = $(call try-run,\
109 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
112 # Usage: cflags-y += $(call as-instr,instr,option1,option2)
114 as-instr = $(call try-run,\
115 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
118 # Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
119 __cc-option = $(call try-run,\
120 $(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
123 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
124 cc-option = $(call __cc-option, $(CC),\
125 $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS),$(1),$(2))
128 # Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
129 hostcc-option = $(call __cc-option, $(HOSTCC),\
130 $(HOSTCFLAGS) $(HOST_EXTRACFLAGS),$(1),$(2))
133 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
134 cc-option-yn = $(call try-run,\
135 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
138 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
139 cc-disable-warning = $(call try-run,\
140 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
143 # Expands to either gcc or clang
144 cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
147 cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
150 # Usage: EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
151 cc-ifversion = $(shell [ $(cc-version) $(1) $(2) ] && echo $(3) || echo $(4))
154 binutils-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/binutils-version.sh $(AS))
155 dtc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/dtc-version.sh $(DTC))
158 # Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
159 cc-ldoption = $(call try-run,\
160 $(CC) $(1) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
163 # Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
164 ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
167 # Usage: KBUILD_ARFLAGS := $(call ar-option,D)
168 # Important: no spaces around options
169 ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
172 # Note this is mainly for HJ Lu's 3 number binutil versions
173 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
176 # Usage: $(call ld-ifversion, -ge, 22252, y)
177 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
182 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
184 # $(Q)$(MAKE) $(build)=dir
185 build := -f $(srctree)/scripts/Makefile.build obj
188 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.modbuiltin obj=
190 # $(Q)$(MAKE) $(modbuiltin)=dir
191 modbuiltin := -f $(srctree)/scripts/Makefile.modbuiltin obj
194 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
196 # $(Q)$(MAKE) $(dtbinst)=dir
197 dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
200 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
202 # $(Q)$(MAKE) $(clean)=dir
203 clean := -f $(srctree)/scripts/Makefile.clean obj
206 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.headersinst obj=
208 # $(Q)$(MAKE) $(hdr-inst)=dir
209 hdr-inst := -f $(srctree)/scripts/Makefile.headersinst obj
211 # Prefix -I with $(srctree) if it is not an absolute path.
212 # skip if -I has no parameter
213 addtree = $(if $(patsubst -I%,%,$(1)), \
214 $(if $(filter-out -I/% -I./% -I../%,$(1)),$(patsubst -I%,-I$(srctree)/%,$(1)),$(1)),$(1))
216 # Find all -I options and call addtree
217 flags = $(foreach o,$($(1)),$(if $(filter -I%,$(o)),$(call addtree,$(o)),$(o)))
220 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
221 echo-cmd = $(if $($(quiet)cmd_$(1)),\
222 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
225 cmd = @$(echo-cmd) $(cmd_$(1))
227 # Add $(obj)/ for paths that are not absolute
228 objectify = $(foreach o,$(1),$(if $(filter /%,$(o)),$(o),$(obj)/$(o)))
231 # if_changed - execute command if any prerequisite is newer than
232 # target, or command line has changed
233 # if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
234 # including used config symbols
235 # if_changed_rule - as if_changed but execute rule instead
236 # See doc/develop/makefiles.rst for more info
238 ifneq ($(KBUILD_NOCMDDEP),1)
239 # Check if both arguments are the same including their order. Result is empty
240 # string if equal. User may override this check using make KBUILD_NOCMDDEP=1
241 arg-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
242 $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
244 arg-check = $(if $(strip $(cmd_$@)),,1)
247 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
249 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
251 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
252 # (needed for the shell)
253 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
255 # Find any prerequisites that is newer than target or that does not exist.
256 # PHONY targets skipped in both cases.
257 any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
259 # Execute command if command has changed or prerequisite(s) are updated.
261 if_changed = $(if $(strip $(any-prereq) $(arg-check)), \
263 $(echo-cmd) $(cmd_$(1)); \
264 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
266 # Execute the command and also postprocess generated .d dependencies file.
267 if_changed_dep = $(if $(strip $(any-prereq) $(arg-check) ), \
269 $(echo-cmd) $(cmd_$(1)); \
270 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp;\
272 mv -f $(dot-target).tmp $(dot-target).cmd, @:)
274 # Usage: $(call if_changed_rule,foo)
275 # Will check if $(cmd_foo) or any of the prerequisites changed,
276 # and if so will execute $(rule_foo).
277 if_changed_rule = $(if $(strip $(any-prereq) $(arg-check) ), \
282 # why - tell why a a target got build
283 # enabled by make V=2
284 # Output (listed in the order they are checked):
285 # (1) - due to target is PHONY
286 # (2) - due to target missing
287 # (3) - due to: file1.h file2.h
288 # (4) - due to command line change
289 # (5) - due to missing .cmd file
290 # (6) - due to target not in $(targets)
291 # (1) PHONY targets are always build
292 # (2) No target, so we better build it
293 # (3) Prerequisite is newer than target
294 # (4) The command line stored in the file named dir/.target.cmd
295 # differed from actual command line. This happens when compiler
297 # (5) No dir/.target.cmd file (used to store command line)
298 # (6) No dir/.target.cmd file and target not listed in $(targets)
299 # This is a good hint that there is a bug in the kbuild file
300 ifeq ($(KBUILD_VERBOSE),2)
302 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
303 $(if $(wildcard $@), \
304 $(if $(strip $(any-prereq)),- due to: $(any-prereq), \
306 $(if $(cmd_$@),- due to command line change, \
307 $(if $(filter $@, $(targets)), \
308 - due to missing .cmd file, \
309 - due to $(notdir $@) not in $$(targets) \
314 - due to target missing \
318 echo-why = $(call escsq, $(strip $(why)))
321 # delete partially updated (i.e. corrupted) files on error
324 # do not delete intermediate files automatically
327 ifdef CONFIG_XPL_BUILD
329 ifeq ($(CONFIG_VPL_BUILD),y)
332 ifeq ($(CONFIG_TPL_BUILD),y)